﻿var cph5 = cph5 || {};

(function (cph5) {
	
    var Grid9Image = (function () {
        function Grid9Image(img, sw, sh, gx, gy, gw, gh, x, y, dw, dh) {
						this.image 	= img;
					
						this.sw	 	= sw;
						this.sh	 	= sh;
						this.gx	 	= gx;
						this.gy  	= gy;
						this.gw  	= gw;
						this.gh  	= gh;
						this.x  	= x;
						this.y  	= y;
						this.dw 	= dw;
						this.dh 	= dh;
						
						
            this._dirty = true;
        }
        
        Grid9Image.prototype.draw = function (context) {
						var swL 	= this.gx;
						var shT 	= this.gy;
						var swM 	= this.gw;
						var shM 	= this.gh;
						var swR 	= this.sw-this.gx-this.gw;
						var shB 	= this.sh-this.gy-this.gh;						
						var sx0		= 0;
						var sx1		= swL;
						var sx2		= this.sw-swR;
						var sy0		= 0;
						var sy1		= shT;
						var sy2 	= this.sh-shB;
						
						var dx0		= this.x;
						var dx1		= this.x+swL;
						var dx2		= this.x+this.dw-swR;
						
						var dy0		= this.y;
						var dy1		= this.y+shT;
						var dy2		= this.y+this.dh-shB;
						
						var dwM 	= this.dw-swL-swR;
						var dhM 	= this.dh-shT-shB;
        		
						context.drawImage(this.image, sx0, sy0, swL, shT, dx0, dy0, swL, shT);
						context.drawImage(this.image, sx1, sy0, swM, shT, dx1, dy0, dwM, shT);
						context.drawImage(this.image, sx2, sy0, swR, shT, dx2, dy0, swR, shT);
						
						context.drawImage(this.image, sx0, sy1, swL, shM, dx0, dy1, swL, dhM);
						context.drawImage(this.image, sx1, sy1, swM, shM, dx1, dy1, dwM, dhM);
						context.drawImage(this.image, sx2, sy1, swR, shM, dx2, dy1, swR, dhM);
		
						context.drawImage(this.image, sx0, sy2, swL, shB, dx0, dy2, swL, shB);
						context.drawImage(this.image, sx1, sy2, swM, shB, dx1, dy2, dwM, shB);
						context.drawImage(this.image, sx2, sy2, swR, shB, dx2, dy2, swR, shB);
		        this._dirty = false;
				}

        return Grid9Image;
    })();
    cph5.Grid9Image = Grid9Image;
    Grid9Image.prototype.__class__ = "cph5.Grid9Image";
    
})(cph5);
