﻿var cph5 = cph5||{};

(function (cph5) {
	
    var RES = (function () {
        function RES() {
          this.data	= {};
        }

				function loadImage(url, loadfunc) {
						var image	= new Image();
					  image.onload 	= onImageComplete;
					  image.onerror = onLoadError;
						image.src			= url;
						
            function onImageComplete(event) {
               image.onerror = null;
              image.onload = null;
					  	if (loadfunc) loadfunc();
            }

            function onLoadError(event) {
              image.onerror = null;
              image.onload = null;
					  	if (loadfunc) loadfunc();
            }
            
            return image;
				}
				
				function loadResource(config,preparedFunc) {
					instance._loadResource(config,preparedFunc);
				}
				RES.loadResource = loadResource;
				
				RES.prototype._loadResource = function(config,preparedFunc) {
					var resonload = config.length;
					var resloaded = 0;
					
					for (var i=0; i<resonload; i++) {
						var name 	= config[i].name;
						var url 	= config[i].url;
						var image = loadImage(url, imageLoadFunc);
					  this.data[name]	= image;
					}
					
					function imageLoadFunc() {
					  	resloaded++;
					  	if (resloaded >= resonload) {
					  		if (preparedFunc) preparedFunc();
					  	}
					}
				};
				
				RES.getRes = function(name) {return instance.data[name]};

        return RES;
    })();
    RES.prototype.__class__ = "cph5.RES";
    
    var instance = new RES();
    cph5.RES = RES;
    
})(cph5);

