﻿var pne = pne||{};

(function(pne) {
	
	var Scene = (function() {
			
						
			function Scene(stage, nval, pval,lastText,lastIsnval,lastValue)
			{
				this._mode					= 0;
				this._clickScore 		= 0;
				this._isnval				= true;
	      this._clickCount 		= 0;
				this._isnval				= true;
				this._nSpeakText=[
					"太失望！",
					"无力吐槽",
					"负分滚粗！",
					"我可以骂人吗！？",
					"丫有病吧！！",
					"太没人性了！",
					"丧心病狂！",
					"人渣！",
					"令人发指！",
					"猪狗不如！"
				];
				
				this._pSpeakText=[
					"点赞！",
					"很好很强大！",
					"哈哈！给力！",
					"太好了！",
					"满满的正能量啊！",
					"怒赞！",
					"感人肺腑啊！",
					"太治愈了！",
					"世界充满爱...",
					"正义的力量！"
				];

				this._stage = stage;
				this._nval 	= nval;
				this._pval 	= pval;
				
				this._floatText = [	new pne.FloatText(new cph5.Label("50px bold sans-serif", "#ffffff", 240, 404, "没啥好说的1", "middle"), 240, 404),
													 	new pne.FloatText(new cph5.Label("50px bold sans-serif", "#ffffff", 240, 404, "没啥好说的2", "middle"), 240, 404),
													 	new pne.FloatText(new cph5.Label("50px bold sans-serif", "#ffffff", 240, 404, "没啥好说的3", "middle"), 240, 404)
													];
				
				this._buttonCircle = new pne.ButtonCircle([cph5.RES.getRes("wave_1"),cph5.RES.getRes("wave_2"),cph5.RES.getRes("wave_3")], 100, 240, 655);
				this._buttonIdleTime = 1500;
				
				this._progress 		= 0.5;
				this._dProgress		= 0;
				this._index		 		= 0;
				this._shareText		= "";
				this._buttonDown 	= false;
				this._button0Down = false;
				this._button1Down = false;
				this._operateIdle	= 0;
				
				this._textCount		= 10;
				this._clickInc		= 1.0 / (this._textCount * 5);
				this._dTextChange	= 1.0 / this._textCount;
				this._baseClickScore 	= 3000/this._textCount;
				this._rangeClickScore = this._baseClickScore*0.2;

				this._arrowDelta	= 0;
				this._arrowDX			= 23*0.5;
				this._arrowDY			= -14*0.5;
				
				this._closeBtnResponseDelay = 0;
				
				this._lastClickTime = Date.now();
				
				this._touchOn				= false;

				if (lastValue > 0) {
					this._isnval 			= lastIsnval;
					this._clickScore 	= lastValue;
					this._shareText		= lastText;
					this._progress		= 1.0;
					this._mode				= 3;
				}
				
			}
			
      Scene.prototype.update = function(delta) {      	
      	if (delta < 0)
      		return;
      		
      	switch(this._mode)
      	{
      		case 0:
      			break;
      		case 1:
      			this._buttonIdleTime += delta;
      			if (this._buttonIdleTime > 1800) {
      				this._buttonCircle.play(2);
      				this._buttonIdleTime = 0;
      			}
      			this._buttonCircle.onUpdate(delta);
      			break;
      		case 2:
      			this._floatText[0].onUpdate(delta);
      			this._floatText[1].onUpdate(delta);
      			this._floatText[2].onUpdate(delta);
      			this._buttonCircle.onUpdate(delta);
      			if (!this._buttonDown) {
      				this._operateIdle += delta;
      				if (this._operateIdle > 1800) {
      					this._operateIdle = 0;
      					this._mode = 3;
      				}
      			}
	        	break;
      		case 3:
      			if (this._progress < 1.0) {
	      			this._buttonIdleTime += delta;
	      			if (this._buttonIdleTime > 1800) {
	      				this._buttonCircle.play(2);
	      				this._buttonIdleTime = 0;
	      			}
	      			this._buttonCircle.onUpdate(delta);
      			
	      			this._arrowDelta += delta;
	      			while(this._arrowDelta > 500)
	      				this._arrowDelta -= 500;
      			}
      			this._closeBtnResponseDelay += delta;
      			if (this._closeBtnResponseDelay > 1000)
      				this._closeBtnResponseDelay = 1000;
	        	break;
        }
      }
      
      Scene.prototype.draw_mode_0 = function(context) {
				cph5.Label.draw(context, "36px sans-serif", "#ffffff", 240, 350, "点击  '正'  或  '负' ", "middle", "middle");
				cph5.Label.draw(context, "36px sans-serif", "#ffffff", 240, 400, "看新闻，我有我脾气！", "middle", "middle");

				context.drawImage(cph5.RES.getRes("btn_red_" + (this._button0Down ? "2" : "1")),		240-60-57, 656-57);
				context.drawImage(cph5.RES.getRes("btn_black_" + (this._button1Down ? "2" : "1")),	240+60-57, 656-57);
				
				context.drawImage(cph5.RES.getRes("btn_close"),	415, 25);
      }
      
      Scene.prototype.draw_mode_1 = function(context) {
      	var resBtn = (this._isnval ? "btn_black_" : "btn_red_") + (this._buttonDown ? "2" : "1");
      	var tipText = this._isnval ? "这新闻太负能量了！猛戳加\"负\"" : "这新闻太正能量了！猛戳加\"正\"";

				this._buttonCircle.draw(context);
				
				var h = this._progress*70;
				context.fillStyle=this._isnval ? "#000000" : "#ff0000";
				context.fillRect(240-16/2, 500+70-h, 16, h);
				
				cph5.Label.draw(context, "20px sans-serif", "#ffffff", 240, 527, tipText, "middle", "middle");
				context.drawImage(cph5.RES.getRes(resBtn),		240-57, 655-57);

				context.drawImage(cph5.RES.getRes("btn_close"),	415, 25);
     }
      
      
      Scene.prototype.draw_mode_2 = function(context) {
				this._floatText[0].draw(context);
				this._floatText[1].draw(context);
				this._floatText[2].draw(context);

				this._buttonCircle.draw(context);

      	var resBtn = (this._isnval ? "btn_black_" : "btn_red_") + (this._buttonDown ? "2" : "1");
      	var scoreText = (this._isnval ? "-" : "+") + this._clickScore.toFixed(0);

				cph5.Label.draw(context, "40px sans-serif", "#ff0000", 240, 482, scoreText, "middle", "middle");

				context.drawImage(cph5.RES.getRes(resBtn),	240-57, 655-57);
				
				var h = this._progress*70;
				context.fillStyle=this._isnval ? "#000000" : "#ff0000";
				context.fillRect(240-16/2, 500+70-h, 16, h);
				
				context.drawImage(cph5.RES.getRes("btn_close"),	415, 25);
      }
      
      Scene.prototype.draw_mode_3 = function(context) {
				var text1 = this._clickScore.toFixed(0)+(this._isnval ? "点负能量" : "正能量");
				if (this._progress < 1.0) {
					this._buttonCircle.draw(context);
				}else {
					context.drawImage(cph5.RES.getRes("wave_3"),		240-133*0.5, 655-133*0.5);
				}
				cph5.Label.draw(context, "34px sans-serif", "#ffffff", 240, 190, "你向这条新闻发出了", "middle", "middle");
				cph5.Label.draw(context, "34px sans-serif", "#ffffff", 240, 238, text1, "middle", "middle");
				
				if (this._progress < 1.0) {
					var text2 = "我要继续发"+(this._isnval ? "负能量>>" : "正能量>>");
					cph5.Label.draw(context, "20px sans-serif", "#ffffff", 240, 290, text2, "middle", "middle");
					
					var arrowX = this._arrowDelta * this._arrowDX / 500-23*0.5;
					var arrowY = this._arrowDelta * this._arrowDY / 500+14*0.5;
					context.drawImage(cph5.RES.getRes("c_arrow"),		295+arrowX, 585+arrowY);
					context.drawImage(cph5.RES.getRes("c_text"),		325, 570);
				}

      	var resBtn = (this._isnval ? "btn_black_" : "btn_red_") + (this._buttonDown ? "2" : "1");
      	var scoreText = (this._isnval ? "-" : "+") + this._clickScore.toFixed(0);

				cph5.Label.draw(context, "40px sans-serif", "#ff0000", 240, 470, scoreText, "middle", "middle");
				context.drawImage(cph5.RES.getRes(resBtn),	240-114*0.5, 655-114*0.5);
				
				var h = this._progress*70;
				context.fillStyle=this._isnval ? "#000000" : "#ff0000";
				context.fillRect(240-16/2, 500+70-h, 16, h);
				
				context.drawImage(cph5.RES.getRes("btn_black"),	47, 337);
				cph5.Label.draw(context, "20px sans-serif", "#ffffff", 47+180/2, 337+45/2, "提交", "middle", "middle");

				context.drawImage(cph5.RES.getRes("btn_red"),		247, 337);
				cph5.Label.draw(context, "20px sans-serif", "#ffffff", 247+180/2, 337+45/2, "分享", "middle", "middle");
				
				context.drawImage(cph5.RES.getRes("btn_close"),	415, 25);
      }
      
      
      Scene.prototype.draw = function(context) {
//				if (window.cph5_debug) {
//      		context.globalAlpha = 0.5;
//    	  	context.fillStyle = "#000000";
//  	    	context.fillRect(0,0,480,800);
//	      	context.globalAlpha =1.0;
//  			}  	
				switch(this._mode)
				{
					case 0:
						this.draw_mode_0(context);
						break;
					case 1:
						this.draw_mode_1(context);
						break;
					case 2:
						this.draw_mode_2(context);
						break;
					case 3:
						this.draw_mode_3(context);
						break;
				}
      }
      
      Scene.prototype.touchBegan = function(x, y) {
      	this._touchOn				= true;
				this._operateIdle = 0;
				switch(this._mode)
				{
					case 0:
						if (y>656-57 && y<656+57) {
							if (x>240-60-57 && x<240-60+57) {//press p button
								this._button0Down = true;
								this._button1Down = false;
								return;
							}
	
							if (x>240+60-57 && x<240+60+57) {//press n button
							this._button0Down = false;
							this._button1Down = true;
								return;
							}
						}
						break;
					case 1:
					case 2:
					case 3:
						if (x>240-133*0.5 && x<240+133*0.5 && y>655-133*0.5 && y<655+133*0.5) {
							this._buttonDown = true;
						}
						break;
				}
				if (this._progress >= 1.0) {
						this._buttonDown = false;
				}
      }
      
      Scene.prototype.computeClickScore = function() {
					var thisTime = Date.now();
					var dTime = thisTime-this._lastClickTime;
					this._lastClickTime = thisTime;
					var addScore = Math.floor( dTime<=700 ? (-13.1/60*dTime+140+(130/6)) : (9+Math.random()*6) );

					this._clickCount ++;
					this._clickScore += addScore;
      }
      
      Scene.prototype.touchEnd = function(x, y) {
      	var isClick = false;
      	if (this._touchOn)
      		isClick = true;
      	this._touchOn				= false;
				
				this._button0Down = false;
				this._button1Down = false;
     		this._buttonDown = false;
				this._operateIdle = 0;
				
				if (x>415 && x<415+40 && y>25 && y<25+40) {//press close
					console.log("press close");
					if (this._mode == 2) {
							this._closeBtnResponseDelay = 0;
							this._mode = 3;
							return;
					}
					if (this._mode == 3 && this._progress<1.0 && this._closeBtnResponseDelay < 500) {
						return;
					}
					
					if (window.pnehandler) {
						var step = 0;
						switch(this._mode)
						{
							case 0:
								step = 0;
								break;
							case 1:
								step = this._isnval ? 1 : 2;
								break;
							case 2:
								step = this._isnval ? 3 : 4;
								break;
							case 3:
								step = this._isnval ? 5 : 6;
								break;
						}
						window.pnehandler.pneaction("close", ""+step,  this._clickScore.toFixed(0), "");
					}
					this._mode = 4;
					return;
				}
      	
				switch(this._mode)
				{
					case 0:
						if (y>656-57 && y<656+57) {
							if (x>240-60-57 && x<240-60+57) {//press p button
								this._progress = this._clickInc;
								this._isnval = false;
								this._lastClickTime = Date.now();
								this._mode = 1;
								return;
							}
	
							if (x>240+60-57 && x<240+60+57) {//press n button
								this._progress = this._clickInc;
								this._isnval = true;
								this._lastClickTime = Date.now();
								this._mode = 1;
								return;
							}
						}
						break;
					case 1:
						if (x>240-133*0.5 && x<240+133*0.5 && y>655-133*0.5 && y<655+133*0.5) {
							this._progress 	= this._clickInc;
							this._dProgress	= this._clickInc;

							this.computeClickScore();
							
							this._mode 			= 2;

							this._index 		= 0;
							this._shareText = this._isnval ? this._nSpeakText[this._index] : this._pSpeakText[this._index];

							var floatIndex = this._index % 3;
							this._floatText[floatIndex].label.setString(this._shareText);
							this._floatText[floatIndex].alpha = 0;
							this._floatText[floatIndex].scaleTo(0, 	0.5+1*0.7/5);
							this._floatText[floatIndex].setPosition(240, 450-floatIndex*30);
							this._floatText[floatIndex].moveTo(300, 240, 390-floatIndex*70);
							this._floatText[floatIndex].fadeTo(300, 1.0);
							return;
						}
						break;
					case 2:
						if (!isClick)
							return;
						if (x>240-133*0.5 && x<240+133*0.5 && y>655-133*0.5 && y<655+133*0.5) {
							if (this._progress < 1.0) {
								this._progress 	+= this._clickInc;
								this._dProgress += this._clickInc;

								this.computeClickScore();
							

								if (this._progress >= 1.0) {
									this._progress = 1.0;
									this._closeBtnResponseDelay = 1000;
									this._mode = 3;
									return;
								}
								
      					this._buttonCircle.play(1);
      					
								if (this._index < this._textCount -1) {
									if (this._dProgress > this._dTextChange) {
										this._dProgress -= this._dTextChange;
	
										var floatIndex = this._index % 3;
										//this._floatText[floatIndex].fadeTo(200, 0.0);
										
										this._index	+= 1;
										this._shareText = this._isnval ? this._nSpeakText[this._index] : this._pSpeakText[this._index];
										floatIndex = this._index % 3;
										
										this._floatText[floatIndex].label.setString(this._shareText);
										this._floatText[floatIndex].scaleTo(0, 0.5);
										this._floatText[floatIndex].alpha = 0;
										this._floatText[floatIndex].setPosition(240, 450-floatIndex*30);
										this._floatText[floatIndex].moveTo(300, 240, 390-floatIndex*70);
										this._floatText[floatIndex].fadeTo(300, 1.0);
										
										return;
									}
								}
								
								floatIndex = this._index % 3;
								for (var i=0;i<3;i++) {
									if (i==floatIndex)
										continue;
									if (this._floatText[i].alpha > 0) {
										var alphaTo = this._floatText[i].alpha - 0.26;
										if (alphaTo < 0)
											alphaTo = 0;
										console.log("alphaTo:"+alphaTo);
										
										this._floatText[i].fadeTo(200, alphaTo);
									}
								}
								
								floatIndex = this._index % 3;
								this._floatText[floatIndex].scaleTo(0, 	0.5+(this._clickCount-this._index*5+1)*0.7/5);
								this._floatText[floatIndex].scaleTo(230, 	0.5+(this._clickCount-this._index*5)*0.7/5);
							}
							return;
						}
						break;
					case 3:
						if (	(x>113 && x<113+250 && y>270 && y<270+35) 
								||(x>240-133*0.5 && x<240+133*0.5 && y>655-133*0.5 && y<655+133*0.5)) {
							if (this._progress < 1.0) {
								this._buttonIdleTime = 1500;
								this._closeBtnResponseDelay = 0;
								this._mode = 2;
								this.touchEnd(x,y);
							}
							return;
						}
						
						if (x>47 && x<47+180 && y>337 && y<337+45) {//press ok
							console.log("press ok "+this._shareText);
							if (window.pnehandler) {
								window.pnehandler.pneaction("ok", this._isnval?"true":"false",  this._clickScore.toFixed(0), this._shareText);
							}
							this._mode = 4;
							return;
						}

						if (x>247 && x<247+180 && y>337 && y<337+45) {//press share
							console.log("press share "+this._shareText);
							if (window.pnehandler) {
								window.pnehandler.pneaction("share", this._isnval?"true":"false",  this._clickScore.toFixed(0), this._shareText);
							}
							this._mode = 4;
							return;
						}

						break;
				}
      }
			
			return Scene;
   	})();
   
		pne.Scene = Scene;
		Scene.prototype.__class__ = "pne.Scene";
   
})(pne);