﻿var pne = pne||{};

(function (pne) {
	
   var EnergyLabel = (function () {
        function EnergyLabel(is_n_energy, x, y, value) {
          this._dirty 			= true;
        	this.is_n_energy 	= is_n_energy;
        	this.x = x;
        	this.y = y;
        	this.value 	= value;
					this.bg 		= cph5.RES.getRes((this.is_n_energy ? "value_bg_n" : "value_bg_p"));
					this.label 	= new cph5.Label("bold 20px sans-serif", this.is_n_energy ? "#000000" : "#ff0000", x, y, (is_n_energy ? "-" : "+")+value);
        }
			
				EnergyLabel.prototype.setPosition = function(x,y) {
        	this.x = x;
        	this.y = y;
        	this.label.x = x;
        	this.label.y = y;
        	this._dirty = true;
				};
				EnergyLabel.prototype.setValue = function(value) {
					if (this.value != value) {
						this.value = value;
						var str = (this.is_n_energy ? "-" : "+")+value.toFixed(0);
						this.label.setString(str);
						this._dirty = true;
					}
				};
				
				EnergyLabel.prototype.draw = function(context) {
					var width = this.label.getWidth(context);
					
					var left = this.x - width/2 - 15;
					context.drawImage(this.bg, 0, 0, 15, 30, 
																		 left, this.y-15, 15, 30);					
					left += 15;
					context.drawImage(this.bg, 15, 0, 30, 30, 
																		 left, this.y-15, width, 30);					
					left += width;
					context.drawImage(this.bg, 45, 0, 15, 30, 
																		 left, this.y-15, 15, 30);					

					this.label.draw(context);
					
					this._dirty = false;
				};

        return EnergyLabel;
    })();
    
    pne.EnergyLabel = EnergyLabel;
    EnergyLabel.prototype.__class__ = "pne.EnergyLabel";
    
})(pne);
