﻿var pne = pne||{};

(function(pne) {
	
	var Scene = (function() {
			
			var _mode					= 0;
			var _ticktime 		= 10*1000;
			var	_clickScore 	= 0;
			var _arrowShiftY 	= 0;
			var _valueAddText = "";
			var _valueAddTime = 0;
      var	_downSpeed		= 0;
      var _upSpeed 			= 0.1;
      var _clickCount 	= 0;
			
			var _nSpeakText=[
				[
				"呵呵",
				"没啥好说的",
				"这种事情啥时候少过",
				"无语泪先流……"
				],
				[
				"我的煞气快控制不住了……",
				"要用全部的黄河水才能平复我的心情！",
				"我一口盐水喷死你！",
				"谁来告诉我，这不是真的！"
				],
				[
				"已经没有词语能够描述我的心情了！",
				"左勾拳！！右勾拳！！我打！！！",
				"已经出离愤怒了！",
				"我*&……￥%&！",
				"简直就是XX不如！"
				]
			];
			
			var _pSpeakText=[
				[
					"支持！",
					"赞！",
					"顶！"
				],
				[
					"太感动了~",
					"好样的！",
					"瞬间觉得一切都是那么得美好！",
					"慢慢的正能量！"
				],
				[
					"用生命点赞！",
					"断指赞！",
					"超人的潜质被深深地激发出来了！",
					"我的全身都在散发着光芒！"
				]
			];
						
			function Scene(stage, nval, pval)
			{
				this._stage = stage;
				this._nval 	= nval;
				this._pval 	= pval;
				this._text0  = new cph5.Label("bold 60px sans-serif", "#ff0000", 240,325, "猛戳按钮");
				this._text1  = new cph5.Label("bold 30px sans-serif", "#ff0000", 240,385, "以发表态度");
				this._timer  = new cph5.Label("bold 30px sans-serif", "#ffffff", 240, 40, "10'00");
				this._head_n = new pne.EnergyBar(true,  48,581,251,1);
				this._head_p = new pne.EnergyBar(false,255,581,251,1);
				this._nValue = new pne.EnergyLabel(true, 137, 545, nval);
				this._pValue = new pne.EnergyLabel(false,340, 545, pval);
				
				this._buttonOK		= new cph5.Grid9Image(cph5.RES.getRes("title_bg_p"), 30,38, 4,4,22,30, 97,575,286,58);
				this._buttonOKLabel = new cph5.Label("bold 30px sans-serif", "#ffffff", 240,604, "好的");
				
				this._buttonShare	= new cph5.Grid9Image(cph5.RES.getRes("title_bg_n"), 30,38, 4,4,22,30, 97,655,286,58);
				this._buttonShareLabel = new cph5.Label("bold 30px sans-serif", "#ffffff", 240,684, "分享");

				this._speekBubble = null;
			}
			
    	function formatTime(t) {
        if (t < 0)
            t = 0;
        var s = "00000" + t.toFixed(0);
        var len = s.length;
        var ts = s.substring(len - 5, len - 3) + "' " + s.substring(len - 3, len - 1);
        return ts;
    	}
			
    	function formatEnergyValue(val,isnval) {
        if (val < 0)
            val = 0;
        var s = "00000000" + val.toFixed(0);
        var len = s.length;
        var ts = (isnval?"-":"+")+s.substring(len - 8, len);
        return ts;
    	}

      Scene.prototype.update = function(delta) {
      	if (delta < 0)
      		return;
      	switch(_mode)
      	{
      		case 0:
	      		_arrowShiftY += 0.010*delta;
	      		while (_arrowShiftY >= 5)
	      			_arrowShiftY -= 5;
      			break;
      		case 1:
      		case 2:
	        	if (_ticktime > 0) {
	        		_valueAddTime += delta;
							if (this._speekBubble) this._speekBubble.onUpdate(delta);
	        		
	        		_ticktime -= delta;
	        		if (_ticktime < 0)
	        			_ticktime = 0;
	        		this._timer.setString(formatTime(_ticktime));
	        		if (_ticktime <= 0) {
	        			if (_mode == 1)
	        				_mode = 3;
	        			else
	        				_mode = 4;
								this._speekBubble.y = 275;
							} else {
								if (_mode == 1) {
									var percent = this._head_n.percent - _downSpeed*delta/1000.0;
									this._head_n.setProgress(percent);
									this._head_n.onUpdate(delta);
								} else {
									var percent = this._head_p.percent - _downSpeed*delta/1000.0;
									this._head_p.setProgress(percent);
									this._head_p.onUpdate(delta);
								}
							}


	        	}
	        	break;
        }
      }
      
      Scene.prototype.draw_mode_0 = function(context) {
      	
				context.drawImage(cph5.RES.getRes("time_bg"), 200, 19);
				context.drawImage(cph5.RES.getRes("button_close"), 406, 9);
				context.drawImage(cph5.RES.getRes("arrow_n"), 124, 753-_arrowShiftY);
				context.drawImage(cph5.RES.getRes("arrow_p"), 327, 753-_arrowShiftY);
				
				this._text0.draw(context);
				this._text1.draw(context);
				
				this._timer.draw(context);
				this._nValue.draw(context);
				this._pValue.draw(context);
				
				this._head_n.draw(context);
				this._head_p.draw(context);
      }
      
      Scene.prototype.draw_mode_1 = function(context) {
      	context.globalAlpha = 0.5;
				this._head_p.draw(context);
      	context.globalAlpha = 1.0;
      	
				context.drawImage(cph5.RES.getRes("time_bg"), 200, 19);
				context.drawImage(cph5.RES.getRes("button_close"), 406, 9);
				
				context.drawImage(cph5.RES.getRes("dialog_bg_1"), 112, 75);
				
				if (_valueAddTime < 500)
					cph5.Label.draw(context, "20px sans-serif", "#000000", 137, 200, _valueAddText);

				if (this._speekBubble) this._speekBubble.draw(context);

				this._timer.draw(context);
				this._nValue.draw(context);
				
				this._head_n.draw(context);
      }
      
      Scene.prototype.draw_mode_2 = function(context) {
      	context.globalAlpha = 0.5;
				this._head_n.draw(context);
      	context.globalAlpha = 1.0;
      	
				context.drawImage(cph5.RES.getRes("time_bg"), 200, 19);
				context.drawImage(cph5.RES.getRes("button_close"), 406, 9);

				context.drawImage(cph5.RES.getRes("dialog_bg_1"), 105, 75);

				if (_valueAddTime < 500)
					cph5.Label.draw(context, "20px sans-serif", "#ff0000", 340, 200, _valueAddText);
				
				if (this._speekBubble) this._speekBubble.draw(context);

				this._timer.draw(context);
				this._pValue.draw(context);
				
				this._head_p.draw(context);
      }
      
      Scene.prototype.draw_mode_3 = function(context) {

				context.drawImage(cph5.RES.getRes("button_close"), 406, 9);

				context.drawImage(cph5.RES.getRes("dialog_bg_2"), 105, 215);

				cph5.Label.draw(context, "bold 30px sans-serif", "#000000", 240, 96, "你向这条新闻发出了");
				cph5.Label.draw(context, "bold 30px sans-serif", "#000000", 240, 196, "负能量", "left", 	"bottom");
				cph5.Label.draw(context, "bold 70px sans-serif", "#000000", 240, 210, _clickScore.toFixed(0), "right", 	"bottom");
	
				var str="新闻总能量";
				for (var i=0; i<5; i++) {
					context.drawImage(cph5.RES.getRes("title_bg_n"), 155+i*34, 388);
					cph5.Label.draw(context, "bold 30px sans-serif", "#ffffff", 155+i*34+15,388+19, str.charAt(i));
				}

				str = formatEnergyValue(this._nval+_clickScore,true);
				for (var i=0; i<9; i++) {
					context.drawImage(cph5.RES.getRes("value_bg"), 26+i*49, 441);
					cph5.Label.draw(context, "bold 40px sans-serif", "#000000", 26+i*49+22,441+32, str.charAt(i));
				}

				if (this._speekBubble) this._speekBubble.draw(context);

				if (_mode == 3) {
					this._buttonOK.draw(context);
					this._buttonOKLabel.draw(context);
					
					this._buttonShare.draw(context);
					this._buttonShareLabel.draw(context);
				}
      }
      
      Scene.prototype.draw_mode_4 = function(context) {

				context.drawImage(cph5.RES.getRes("button_close"), 406, 9);

				context.drawImage(cph5.RES.getRes("dialog_bg_2"), 112, 215);

				cph5.Label.draw(context, "bold 30px sans-serif", "#ff0000", 240,  96, "你向这条新闻发出了");
				cph5.Label.draw(context, "bold 30px sans-serif", "#ff0000", 240, 196, "正能量", "left", 	"bottom");
				cph5.Label.draw(context, "bold 70px sans-serif", "#ff0000", 240, 210, _clickScore.toFixed(0), "right", 	"bottom");
	
				var str="新闻总能量";
				for (var i=0; i<5; i++) {
					context.drawImage(cph5.RES.getRes("title_bg_p"), 155+i*34, 388);
					cph5.Label.draw(context, "bold 30px sans-serif", "#ffffff", 155+i*34+15,388+19, str.charAt(i));
				}

				str = formatEnergyValue(this._pval+_clickScore,false);
				for (var i=0; i<9; i++) {
					context.drawImage(cph5.RES.getRes("value_bg"), 26+i*49, 441);
					cph5.Label.draw(context, "bold 40px sans-serif", "#ff0000", 26+i*49+22,441+32, str.charAt(i));
				}

				if (this._speekBubble) this._speekBubble.draw(context);
				
				if (_mode == 4) {
					this._buttonOK.draw(context);
					this._buttonOKLabel.draw(context);
					
					this._buttonShare.draw(context);
					this._buttonShareLabel.draw(context);
				}

      }
      
      Scene.prototype.draw = function(context) {
        context.clearRect(0, 0, 480, 800);
				
				switch(_mode)
				{
					case 0:
						this.draw_mode_0(context);
						break;
					case 1:
						this.draw_mode_1(context);
						break;
					case 2:
						this.draw_mode_2(context);
						break;
					case 3:
					case 5:
						this.draw_mode_3(context);
						break;
					case 4:
					case 6:
						this.draw_mode_4(context);
						break;
				}
      }
      
      Scene.prototype.touchBegan = function(x, y) {
				switch(_mode)
				{
					case 0:
					case 1:
					case 2:
						this._head_n.onTouchBegan(x, y);
						this._head_p.onTouchBegan(x, y);
						break;
					case 3:
						break;
				}
      }
      
      Scene.prototype.processClick = function() {
      		_clickCount++;
      		_valueAddTime = 0;
					var scoreAdd = 14.0*(10-_ticktime/1000.0);
					if (scoreAdd <= 0)
						scoreAdd = 14;
					if (Math.random() < 0.05)
						scoreAdd *= 2;
					_clickScore += scoreAdd;
					_downSpeed = (10-_ticktime/1000.0) *0.14;
					if (_downSpeed <= 0)
						_downSpeed = 0.1;
					if (_mode == 1) {
							_valueAddText = "-"+scoreAdd.toFixed(0);
							this._nValue.setValue(_clickScore+this._nval);					
							var percent = this._head_n.percent + _upSpeed;
							this._head_n.setProgress(percent);
							if (this._head_n.percent >= 1.0) {
								_mode = 3;
								this._speekBubble.y = 275;
								var timeScoreAdd = _ticktime/1000.0*300.0;
								_clickScore += timeScoreAdd;
							}
					} else if (_mode == 2) {
							_valueAddText = "+"+scoreAdd.toFixed(0);
							this._pValue.setValue(_clickScore+this._pval);
							var percent = this._head_p.percent + _upSpeed;
							this._head_p.setProgress(percent);
							if (this._head_p.percent >= 1.0) {
								_mode = 4;
								this._speekBubble.y = 275;
								var timeScoreAdd = _ticktime/1000.0*300.0;
								_clickScore += timeScoreAdd;
							}
					}
					if (this._speekBubble) this._speekBubble.setValue(_clickScore);
      }
      
      Scene.prototype.touchEnd = function(x, y) {
				if (x>406 && x<466 && y>9 && y<69) {//press close
					pnehandler.pneaction("close", ""+_mode,  _clickScore.toFixed(0), "");
					return;
				}
      	
				switch(_mode)
				{
					case 0:
						if (this._head_n.onTouchEnd(x, y)) {
							_ticktime = 10*1000;
							_mode = 1;
							this._nValue.setPosition(137, 225);
							this._head_p.clickable = false;
							
							this.processClick();
							this._speekBubble = new pne.SpeakBubble(_nSpeakText, 240, 135, _clickScore);

						}
						if (this._head_p.onTouchEnd(x, y)) {
							_ticktime = 10*1000;
							_mode = 2;
							this._pValue.setPosition(342, 225);
							this._head_n.clickable = false;
							
							this.processClick();
							this._speekBubble = new pne.SpeakBubble(_pSpeakText, 240, 135, _clickScore);
						}
						break;
					case 1:
						if (this._head_n.onTouchEnd(x, y)) {
							this.processClick();
						}
						
						this._head_p.onTouchEnd(x, y);
						break;
					case 2:
						this._head_n.onTouchEnd(x, y);
						
						if (this._head_p.onTouchEnd(x, y)) {
							this.processClick();
						}
						break;
					case 3:
					case 4:
							if (x>97 && x<97+286 && y>575 && y<575+58) {//press ok
									var text = this._speekBubble ? this._speekBubble.text : "";
									pnehandler.pneaction("ok", _mode==3?"true":"false",  _clickScore.toFixed(0), text);
									_mode += 2;
							} else if (x>97 && x<97+286 && y>655 && y<655+58){//press share
									var text = this._speekBubble ? this._speekBubble.text : "";
									pnehandler.pneaction("share", _mode==3?"true":"false",  _clickScore.toFixed(0), text);
									_mode += 2;
							}
						break;
				}
      }
			
			return Scene;
   	})();
   
		pne.Scene = Scene;
		Scene.prototype.__class__ = "pne.Scene";
   
})(pne);