﻿var pne=pne||{};

(function (pne) {
	
   var SpeakBubble = (function () {
        function SpeakBubble(textArr, x, y, value) {
          this._dirty 	= true;
        	this.x 				= x;
        	this.y 				= y;
        	this.textArr 	= textArr;
        	this.value 		= value;
					this.bg 			= cph5.RES.getRes("dialog_bg_1");
					this.text 		= "";
					this._time		= 0;
					this.randText();
        }
				
				SpeakBubble.prototype.onUpdate = function(delta) {
					this._time += delta;
					if (this._time > 2000) {
						this.randText();
						this._time -= 2000;
					} 
      	}
      	
				SpeakBubble.prototype.setValue = function(value) {
					var oldIndex = 0;
					if (this.value<=200) {
						oldIndex = 0;
					}else if (this.value <=3000) {
						oldIndex = 1;
					}else {
						oldIndex = 2;
					}
					
					var newIndex = 0;
					this.value = value;
					if (this.value<=200) {
						newIndex = 0;
					}else if (this.value <=3000) {
						newIndex = 1;
					}else {
						newIndex = 2;
					}
					
					if (oldIndex != newIndex) {
						this._time = 0;
						this.randText();
					}
      	}

				SpeakBubble.prototype.randText = function() {
					var textArr = [];
					if (this.value<=200) {
						textArr = this.textArr[0];
					}else if (this.value <=3000) {
						textArr = this.textArr[1];
					}else {
						textArr = this.textArr[2];
					}
					
					var rnd 	=	Math.floor( textArr.length * Math.random());
					var index = parseInt(rnd.toFixed(0));
					this.text = textArr[index];
					
        	this._dirty = true;
				};
        
			
				SpeakBubble.prototype.setPosition = function(x,y) {
        	this.x = x;
        	this.y = y;
        	this._dirty = true;
				};

				SpeakBubble.prototype.draw = function(context) {
					//var width = this.label.getWidth(context);
					if (this.text.length <= 8)
						cph5.Label.draw(context, "20px sans-serif", "#000000", this.x, this.y, this.text);
					else {
						var text1 = this.text.substring(0, 8);
						var text2 = this.text.substring(8, this.text.length);
						cph5.Label.draw(context, "20px sans-serif", "#000000", this.x, this.y-12, text1);
						cph5.Label.draw(context, "20px sans-serif", "#000000", this.x, this.y+12, text2);
					}
					
					this._dirty = false;
				};

        return SpeakBubble;
    })();
    
    pne.SpeakBubble = SpeakBubble;
    SpeakBubble.prototype.__class__ = "pne.SpeakBubble";
    
})(pne);
