﻿var pne=pne||{};

(function (pne) {
	
   var ButtonCircle = (function () {
        function ButtonCircle(frames, frameTime, x, y) {
          this._dirty 	= true;
        	this.x 				= x;
        	this.y 				= y;
					this._frame		= 0;
					this._frames  = frames;
					this._frameCount = frames.length;
					this._frameTime  = frameTime;
					this._times		= 0;
					this._time		= 0;
        }
        
				ButtonCircle.prototype.play = function(times) {
					if (times <= 0) {
						this._frame			= 0;
						this._times			= 0;
					this._time				= 0;
						return;
					}
					
					this._time				= 0;
					this._frame				= 0;
					this._times				= times;
      	}
      	
				ButtonCircle.prototype.stop = function() {
					this._time	= 0;
					this._times	= 0;
					this._frame	= 0;
				}      	
      	
				ButtonCircle.prototype.onUpdate = function(delta) {
					if (this._times > 0) {
						this._time += delta;
						while (this._time >= this._frameTime) {
							this._time -= this._frameTime;
							this._frame++;
							this._dirty = true;
							if (this._frame >= this._frameCount) {
								this._frame  = 0;
								this._times -= 1;
								if (this._times <= 0)
									break;
							}
						}
					}
      	}
      	
				ButtonCircle.prototype.draw = function(context) {
					
					if (this._times > 0) {
						context.drawImage(this._frames[this._frame],	this.x-133*0.5, this.y-133*0.5);
					}
        	this._dirty = false;
				};
        
			
				ButtonCircle.prototype.setPosition = function(x,y) {
        	this.x = x;
        	this.y = y;
        	this._dirty = true;
				};

        return ButtonCircle;
    })();
    
    pne.ButtonCircle = ButtonCircle;
    ButtonCircle.prototype.__class__ = "pne.ButtonCircle";
    
})(pne);
